unit UApes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;
type
  TApeType = (atGorilla, atOrangutan, atChimp);

  TApe = class
  public
    procedure print;virtual;abstract;
  end;

  TApeClass = class of TApe;
  { TGorrila }

  TGorrila = class(TApe)
  public
    procedure Print;override;
  end;

  { TOrangutan }

  TOrangutan = class(TApe)
  public
    procedure Print;override;
  end;

  { TChimp }

  TChimp = class(TApe)
  public
    procedure Print;override;
    constructor Create;
  end;

  { TApeFactory }

  TApeFactory = class
  public
    class function CreateApe(aType:TApeType):TApe;
  end;

implementation
const
  TheApeClasses: array[TApeType] of TApeClass =  (TGorrila, TOrangutan, TChimp);
{ TGorrila }

procedure TGorrila.Print;
begin
  writeln('Gorrila');
end;

{ TOrangutan }

procedure TOrangutan.Print;
begin
  writeln('Orangutan');
end;

{ TChimp }

procedure TChimp.Print;
begin
  writeln('Chimp');
end;

constructor TChimp.Create;
begin
  WriteLn('Loadring Chimp!');
end;

{ TApeFactory }

class function TApeFactory.CreateApe(aType : TApeType) : TApe;
begin
  Result := TheApeClasses[aType].Create;
end;

end.
